'use strict';describe('jujulib charmstore',function(){let a;beforeEach(function(){const b={get:sinon.stub(),put:sinon.stub()};a=new window.jujulib.charmstore('local/',b)}),afterEach(function(){a=null}),it('can be instantiated with the proper config values',function(){assert.strictEqual(a.url,'local/v5')}),it('is smart enough to handle missing trailing slash in URL',function(){a=new window.jujulib.charmstore('http://example.com',{}),assert.strictEqual(a.url,'http://example.com/v5')}),describe('_generatePath',function(){it('generates a valid url using provided args',function(){var b=a._generatePath('search/','text=foo');assert.equal(b,'local/v5/search/?text=foo')})}),describe('getLogoutUrl',function(){it('returns a valid logout url',function(){var b=a.getLogoutUrl();assert.equal(b,'local/v5/logout')})}),describe('_transformQueryResults',function(){var b,c={Results:[{entityType:'charm',id:'cs:precise/foo',Id:'cs:precise/foo',Meta:{"extra-info":{"bzr-owner":''}}},{entityType:'charm',id:'cs:~charmers/precise/foo',Id:'cs:~charmers/precise/foo',Meta:{"extra-info":{"bzr-owner":'charmers'}}},{entityType:'charm',id:'cs:~juju-gui-charmers/precise/foo',Id:'cs:~juju-gui-charmers/precise/foo',Meta:{"extra-info":{"bzr-owner":'juju-gui-charmers'}}},{entityType:'bundle',id:'cs:bundle/foo',Id:'cs:bundle/foo',Meta:{"extra-info":{"bzr-owner":''}}}]};beforeEach(function(){b=sinon.stub()}),afterEach(function(){assert.equal(b.callCount,1)}),it('calls to process query response data for each record',function(){var d=sinon.stub(a,'_processEntityQueryData');a._transformQueryResults(b,null,c),assert.equal(d.callCount,4)}),it('can use a processing function to massage data',function(){a._processEntityQueryData=function(a){return a},a.processEntity=function(a){return'charm'===a.entityType?'It\'s a charm.':'It\'s a bundle.'},a._transformQueryResults(b,null,c);var d=b.lastCall.args[1];assert.equal(d[0],'It\'s a charm.'),assert.equal(d[1],'It\'s a charm.'),assert.equal(d[2],'It\'s a charm.'),assert.equal(d[3],'It\'s a bundle.')}),it('errors when no data is provided even if there is no error',function(){a._transformQueryResults(b,null,null),assert.equal(b.args[0][0],'no entity data returned, can you access the charmstore?')})}),describe('_lowerCaseKeys',function(){it('can recursively transform an objects keys to lowercase',function(){var b={};a._lowerCaseKeys({Baz:'1',Foo:{Bar:{Baz:'1'}}},b),assert.deepEqual(b,{baz:'1',foo:{bar:{baz:'1'}}})}),it('can skip one level of keys in an object',function(){var b={};a._lowerCaseKeys({Baz:'1',Foo:{Bar:{Baz:'1'}},Fee:'2'},b,0),assert.deepEqual(b,{Baz:'1',Foo:{bar:{baz:'1'}},Fee:'2'})})}),describe('_processEntityQueryData',function(){it('can properly transform v5 charm data',function(){const b=a._processEntityQueryData({Id:'cs:trusty/mongodb-9',Meta:{"charm-metadata":{Name:'mongodb',Provides:{db:{Name:'db',Role:'requirer',Interface:'mongo',Optional:!1,Limit:1,Scope:'global'}}},owner:{User:'hatch'},"extra-info":{"bzr-url":'cs:precise/mongodb'},"revision-info":{Revisions:['rev1','rev2','rev4']},"charm-config":{Options:{"foo-optn":{Default:'foo',Description:'foo is awesome',Type:'String'},barOptn:{Default:'bar',Description:'bar is less awesome',Type:'String'}}},"charm-metrics":{Metrics:{metric:'metric'}},published:{Info:[{Channel:'stable',Current:!0},{Channel:'edge',Current:!1}]},stats:{ArchiveDownloadCount:10},"supported-series":{SupportedSeries:['precise','trusty']}}});assert.deepEqual(b,{id:'cs:trusty/mongodb-9',channels:[{name:'stable',current:!0},{name:'edge',current:!1}],downloads:10,entityType:'charm',is_approved:!0,is_subordinate:!1,metrics:{metric:'metric'},owner:'hatch',revisions:['rev1','rev2','rev4'],code_source:{location:'cs:precise/mongodb'},name:'mongodb',relations:{provides:{db:{name:'db',role:'requirer',interface:'mongo',optional:!1,limit:1,scope:'global'}},requires:{}},options:{"foo-optn":{default:'foo',description:'foo is awesome',type:'String'},barOptn:{default:'bar',description:'bar is less awesome',type:'String'}},series:['precise','trusty']})}),it('handles missing extra-info data',function(){var b=a._processEntityQueryData({Id:'cs:trusty/mongodb-9',Meta:{"charm-metadata":{Name:'mongodb',Provides:{}},"extra-info":{},"charm-config":{Options:{}},stats:{ArchiveDownloadCount:42}}});assert.strictEqual(b.owner,void 0),assert.strictEqual(b.code_source.location,void 0),assert.deepEqual(b.revisions,[])}),it('can properly transform v4 bundle data',function(){const b=a._processEntityQueryData({Id:'cs:~charmers/bundle/mongodb-cluster-4',Meta:{"bundle-metadata":{Services:''},"bundle-unit-count":{Count:7},owner:{User:'hatch'},"extra-info":{"bzr-url":'lp:~charmers/charms/bundles/mongodb-cluster/bundle'},"revision-info":{Revisions:['rev1','rev2']},stats:{ArchiveDownloadCount:10}}});assert.deepEqual(b,{code_source:{location:'lp:~charmers/charms/bundles/mongodb-cluster/bundle'},channels:[],deployerFileUrl:'local/v5/~charmers/bundle/mongodb-cluster-4/archive/bundle.yaml',description:'',downloads:10,entityType:'bundle',id:'cs:~charmers/bundle/mongodb-cluster-4',is_approved:!1,name:'mongodb-cluster',owner:'hatch',revisions:['rev1','rev2'],services:'',unitCount:7})})}),describe('search',function(){var b;beforeEach(function(){b=sinon.stub(a,'_generatePath').returns('path')}),it('accepts custom filters & calls to generate an api path',function(){a.search({text:'foo'}),assert.equal(b.callCount,1,'generatePath not called'),assert.deepEqual(b.lastCall.args,['search','text=foo&limit=30&autocomplete=1&include=charm-metadata&include=supported-series&include=bundle-metadata&include=extra-info&include=owner'])}),it('accepts a custom limit when generating an api path',function(){a.search({text:'foo'},null,99),assert.equal(b.callCount,1,'generatePath not called'),assert.deepEqual(b.lastCall.args,['search','text=foo&limit=99&autocomplete=1&include=charm-metadata&include=supported-series&include=bundle-metadata&include=extra-info&include=owner'])}),it('calls to make a valid charmstore search request',function(){var b=sinon.stub(a,'_transformQueryResults');a.search({},'cb'),assert.equal(a.bakery.get.callCount,1,'sendGetRequest not called');var c=a.bakery.get.lastCall.args,d=c[2];assert.equal(c[0],'path'),d({target:{responseText:'{}'}}),assert.equal(b.lastCall.args[0],'cb')})}),describe('list',function(){var b;beforeEach(function(){b=sinon.stub(a,'_generatePath').returns('path')}),it('accepts an author & calls to generate an api path',function(){a.list('test-author','cb'),assert.equal(b.callCount,1,'generatePath not called'),assert.deepEqual(b.lastCall.args,['list','owner=test-author&type=charm&include=charm-metadata&include=bundle-metadata&include=bundle-unit-count&include=bundle-machine-count&include=common-info&include=extra-info&include=supported-series&include=stats&include=perm'])}),it('can list bundles',function(){a.list('test-author','cb','bundle');var c=b.lastCall.args[1];assert.equal(-1<c.indexOf('type=bundle'),!0,'bundle not set in query string')}),it('calls to make a valid charmstore list request',function(){var b=sinon.stub(a,'_transformQueryResults');a.list('test-author','cb'),assert.equal(a.bakery.get.callCount,1,'sendGetRequest not called');var c=a.bakery.get.lastCall.args,d=c[2];assert.equal(c[0],'path'),d({target:{responseText:'{}'}}),assert.equal(b.lastCall.args[0],'cb')})}),describe('getDiagramURL',function(){it('can generate a URL for a bundle diagram',function(){assert.equal(a.getDiagramURL('apache2'),'local/v5/apache2/diagram.svg')})}),describe('getBundleYAML',function(){var b;beforeEach(function(){b=sinon.stub()}),it('calls to get the bundle entity',function(){var c=sinon.stub(a,'getEntity'),d=sinon.stub(a,'_getBundleYAMLResponse'),e='bundle/elasticsearch';a.getBundleYAML(e,b);var f=c.lastCall.args;assert.equal(c.callCount,1),assert.equal(f[0],e),f[1]();var g=d.lastCall.args;g[0](),assert.equal(b.callCount,1)}),it('_getBundleYAMLResponse fetches yaml file contents',function(){a._getBundleYAMLResponse(b,null,[{deployerFileUrl:'deployer file'}]);var c=a.bakery.get.lastCall.args;assert.equal(c[0],'deployer file'),c[2](null,{target:{responseText:'yaml'}}),assert.equal(b.callCount,1),assert.equal(b.lastCall.args[1],'yaml')})}),describe('getAvailableVersions',function(){it('makes a request to fetch the ids',function(){a.getAvailableVersions('cs:precise/ghost-5'),assert.equal(a.bakery.get.callCount,1)}),it('calls the success handler with a list of charm ids',function(b){a.getAvailableVersions('cs:precise/ghost-5',function(a,c){a&&assert.fail('callback should not fail.'),assert.deepEqual(c,['cs:precise/ghost-4']),b()});var c=a.bakery.get.lastCall.args;assert.equal(c[0],'local/v5/precise/ghost-5/expand-id'),c[2](null,{target:{responseText:'[{"Id": "cs:precise/ghost-4"}]'}})}),it('calls the failure handler for json parse failures',function(b){a.getAvailableVersions('cs:precise/ghost-5',function(a){a?b():assert.fail('callback should not succeed.')}),a.bakery.get.lastCall.args[2](null,{target:{responseText:'[notvalidjson]'}})})}),describe('whoami',function(){it('queries who the current user is',function(){a.whoami(),assert.equal(a.bakery.get.callCount,1)}),it('calls the success handler with an auth object',function(b){a.whoami(function(a,c){a&&assert.fail('callback should not fail.'),assert.deepEqual(c,{user:'test',groups:[]}),b()});var c=a.bakery.get.lastCall.args;assert.equal(c[0],'local/v5/whoami'),c[2](null,{target:{responseText:'{"User": "test", "Groups": []}'}})}),it('calls the failure handler for json parse failures',function(b){a.whoami(function(a){a?b():assert.fail('callback should not succeed.')}),a.bakery.get.lastCall.args[2]({target:{responseText:'[notvalidjson]'}})})}),describe('getCanonicalId',function(){it('makes a request to fetch the canonical id for an entity',function(){const b=sinon.stub();a.getCanonicalId('cs:xenial/ghost-4',b);const c=a.bakery.get;assert.equal(c.callCount,1);const d=c.args[0][0];assert.equal(d,'local/v5/xenial/ghost-4/meta/id'),c.args[0][2](null,{target:{responseText:'{"Id": "cs:ghost"}'}}),assert.equal(b.callCount,1),assert.deepEqual(b.args[0],[null,'cs:ghost'])}),it('properly calls the callback when there is an error',function(){const b=sinon.stub();a.getCanonicalId('cs:xenial/ghost-4',b);const c=a.bakery.get;assert.equal(c.callCount,1);const d=c.args[0][0];assert.equal(d,'local/v5/xenial/ghost-4/meta/id'),c.args[0][2]('not found'),assert.equal(b.callCount,1),assert.deepEqual(b.args[0],['not found',null])})}),describe('getEntity',function(){it('strips cs from bundle IDs',function(){a.getEntity('cs:foobar',sinon.stub());var b=a.bakery.get.lastCall.args[0];assert.equal(b.indexOf('cs:'),-1,'The string "cs:" should not be found in the path')}),it('calls the correct path',function(){a.getEntity('cs:foobar',sinon.stub());const b=a.bakery.get.lastCall.args[0];assert.strictEqual(b,'local/v5/foobar/meta/any?include=bundle-metadata&include=bundle-machine-count&include=charm-config&include=charm-metadata&include=charm-metrics&include=common-info&include=extra-info&include=id-revision&include=manifest&include=owner&include=published&include=resources&include=revision-info&include=stats&include=supported-series&include=tags')})}),describe('getResources',function(){it('can get resources for a charm',function(){const b=sinon.stub();a.getResources('cs:xenial/ghost-4',b);const c=a.bakery.get;assert.equal(c.callCount,1);const d=c.args[0][0];assert.equal(d,'local/v5/xenial/ghost-4/meta/resources'),c.args[0][2](null,{target:{responseText:'[{"Name":"file1","Type":"file","Path":"file1.zip","Description":"desc.","Revision":5,"Fingerprint":"123","Size":168},{"Name":"file2","Type":"file","Path":"file2.zip","Description":"desc.","Revision":5,"Fingerprint":"123","Size":168}]'}}),assert.equal(b.callCount,1),assert.deepEqual(b.args[0],[null,[{name:'file1',type:'file',path:'file1.zip',description:'desc.',revision:5,fingerprint:'123',size:168},{name:'file2',type:'file',path:'file2.zip',description:'desc.',revision:5,fingerprint:'123',size:168}]])}),it('properly calls the callback when there is an error',function(){const b=sinon.stub();a.getResources('cs:xenial/ghost-4',b);const c=a.bakery.get;assert.equal(c.callCount,1);const d=c.args[0][0];assert.equal(d,'local/v5/xenial/ghost-4/meta/resources'),c.args[0][2]('not found'),assert.equal(b.callCount,1),assert.deepEqual(b.args[0],['not found',null])})})});